=== debian/changelog ===
fairy-stockfish (11.1-1) unstable; urgency=low

  * Initial debian package (Closes: #964232)
  * Base packaging off package stockfish 11-1.

 -- Yann Dirson <dirson@debian.org>  Mon, 27 Jan 2020 21:56:03 +0100
