=== debian/control ===
Source: fairy-stockfish
Section: games
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>= 10)
Standards-Version: 4.5.0
Homepage: https://github.com/ianfab/Fairy-Stockfish

Package: fairy-stockfish
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: xboard | scid | tagua
Description: chess variant engine including support for Chess, Shogi and XiangQi variants
 Fairy-Stockfish is a chess variant engine derived from Stockfish designed
 for the support of fairy chess variants and easy extensibility with more games.
 It can play various regional, historical, and modern chess variants as well as
 games with user-defined rules. For compatibility with graphical user interfaces
 it supports the UCI, UCCI, USI, and CECP/XBoard protocols.
 .
 The goal of the project is to create an engine supporting a large variety of
 chess-like games, equipped with the powerful search of Stockfish. Despite its
 generality the playing strength is on a very high level in almost all supported
 variants. Due to its multi-protocol support Fairy-Stockfish works with almost
 any chess variant GUI.
 .
 Variants larger than 8x8 are only supported on 64-bit platforms.
