=== debian/watch ===
version=3
opts=versionmangle=s/_/./ \
	https://github.com/ianfab/Fairy-Stockfish/releases .*/fairy_sf_?(\d\S*)\.tar\.gz
